#!/usr/bin/python3

import msgpack
import json
import ipaddress
import sys
import os
import redis

ip = ipaddress.ip_address(sys.argv[1])
ipi = int(ip)

r = redis.Redis(host="localhost", port=6379, decode_responses=True)

x = r.get(f"geoip2_{ipi}")
if x:
	print(json.loads(x))
	sys.exit()

pth = os.path.dirname(os.path.realpath(__file__))
with open(os.path.join(pth, "geoip_city.mp"), "rb") as f:
	geoip = msgpack.unpack(f)

for start, end, data in geoip:
	if ipi >= start and ipi <= end:
		r.setex(f"geoip2_{ipi}", 300, json.dumps(data))
		print(data)
		break
